unit grafp;

interface

uses
  SysUtils, Classes, Controls, ExtCtrls,ugraf,Szogpont,Graphics;

type
  Tgrafp = class(TPanel)
  private
    { Private declarations }
  protected
    { Protected declarations }
    shownothing:boolean;
    Procedure Paint; override;

  public
    { Public declarations }
    spk:array[1..100] of TSzogpont;
    colors:array[1..100,1..100] of Tcolor;
    colorstxt:array[1..100,1..100] of Tcolor;
    graff:tgraf;
    lastclickedindex:integer;
    constructor Create(AOwner: TComponent); override;
    Destructor Destroy; override;
    procedure LoadFromFile(FileName:string);
    procedure Clear;
    procedure doconnect(a,b:integer);
    procedure rp;
    procedure msdown(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
    procedure msUp(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
    procedure msMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
  published
    { Published declarations }
  end;

procedure Register;

implementation
procedure TGrafp.Paint;
begin
  inherited Paint;
  rp;
end;
procedure Tgrafp.doconnect(a,b:integer);
 procedure nyilline(x1,y1,x2,y2,d:integer; sz:real);
  function mpipi(p:real):real;
   begin
      while p>=pi do p:=p-2*pi;
      while p<-pi do P:=p+2*pi;
      mpipi:=p
   end;
  procedure newline(x0,y0,d:integer;alf:real);
   var x,y:real;
   begin
     alf:=mpipi(alf);
     if alf=pi/2 then begin x:=0; y:=d end else
     if alf=-pi/2 then begin x:=0; y:=-d end else begin
        if (alf=pi/2)or(alf=-pi/2) then x:=0;
        x:=d/sqrt((sin(alf)*sin(alf))/(cos(alf)*cos(alf)) + 1);
        if (alf>pi/2) or (alf<-pi/2) then x:=-x;
        y:=x*sin(alf)/cos(alf)
     end;
     with canvas do begin
          moveto(x0,y0);
          lineto(trunc(x)+x0,trunc(y)+y0);
     end;
   end;
  var beta:real;
  begin
    if graff.iranyitott then begin
     if x2=x1 then begin beta:=pi/2;
     if y2<y1 then beta:=-beta; end else begin
     beta:=arctan((y2-y1)/(x2-x1));
     IF X2-X1<0 then beta:=beta+pi; end;
     newline((x1+x2) div 2,(y1+y2) div 2,d,beta+pi-sz);
     newline((x1+x2) div 2,(y1+y2) div 2,d,beta+pi+sz);
    end;
     with canvas do begin moveto(x1,y1); lineto(x2,y2); end;
  end;
 var     cx,cy:integer;
 begin
  with graff do if adatok[a,b]<>0 then begin
    canvas.Pen.Color:=colors[a,b];
    canvas.Font.Color:=colorstxt[a,b];
    if shownothing then begin
      canvas.Pen.Color:=color;
      canvas.Font.Color:=color
    end;
    nyilline(koord[a,1],koord[a,2],koord[b,1],koord[b,2],15,pi/6);
    if graff.sulyozott then with canvas do begin
         cx:=(koord[a,1]+koord[b,1]) div 2; cy:=(koord[a,2]+koord[b,2])div 2;
         if (iranyitott) and(a>b) then cy:=cy-textheight(inttostr(graff.adatok[a,b]))+2;
         Textout(cx,cy,inttostr(graff.adatok[a,b]));
     end;
  end;
 end;
procedure Tgrafp.rp;
var i,j:integer;
begin
   with graff do
     for i:=1 to szogpontszam do begin
        for j:=1 to szogpontszam do begin
          doconnect(i,j);
        end;
     end;
end;
procedure Tgrafp.Clear;
var i:integer;
begin
    for i:=1 to graff.szogpontszam do spk[i].Free;
    graff.szogpontszam:=0;
end;
procedure Tgrafp.LoadFromFile(FileName:string);
var i,j:integer;
begin
    Clear;
    graff.loadfromfile(FileName);
    for i:=1 to graff.szogpontszam do begin
        spk[i]:=Tszogpont.Create(Self);
        spk[i].Parent:=Self;
        with spk[i] do begin
           Caption:=inttostr(i);
           Height:=19;
           Width:=19;
           CX:=graff.koord[i,1];
           CY:=graff.koord[i,2];
           index:=i;
           OnMouseDown:=msdown;
           OnMouseUp:=msup;
           OnMouseMove:=msmove;
        end;
    end;
    for i:=1 to graff.szogpontszam do
       for j:=1 to graff.szogpontszam do begin
          colorstxt[i,j]:=$00400080;
          colors[i,j]:=clblack
       end;
     shownothing:=false;
    rp;
end;
procedure Tgrafp.msdown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   Tszogpont(Sender).isdown:=true;
   Tszogpont(Sender).smx:=x; Tszogpont(Sender).smy:=y;
   lastclickedindex:=Tszogpont(Sender).index;
end;

procedure Tgrafp.msUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
Tszogpont(Sender).isdown:=false;
end;

procedure Tgrafp.msMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
  var i:integer;
begin
 with Tszogpont(Sender) do begin
  if isdown then begin
   if left+x-smx>=0 then left:=left+x-smx; if top+y-smy>=0 then top:=top+y-smy;
   shownothing:=true;
   for i:=1 to graff.szogpontszam do begin doconnect(i,index); doconnect(index,i) end;
   shownothing:=false;
   graff.koord[index,1]:=cx;
   graff.koord[index,2]:=cy;
  rp;
  for i:=1 to graff.szogpontszam do spk[i].Repaint;
  end
 end
end;

constructor Tgrafp.Create(AOwner:TComponent);
var i,j:integer;
begin
     inherited Create(AOWner);
     graff:=TGraf.Create;
     graff.szogpontszam:=0;
end;
destructor Tgrafp.Destroy;
begin
     graff.free;
     inherited Destroy;
end;
procedure Register;
begin
  RegisterComponents('Standard', [Tgrafp]);
end;

end.
